// StuDoc.cpp : Implementierung der Klasse CStudentDoc
//

#include "stdafx.h"
#include "ex16b.h"

#include "StuDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStudentDoc

IMPLEMENT_DYNCREATE(CStudentDoc, CDocument)

BEGIN_MESSAGE_MAP(CStudentDoc, CDocument)
	//{{AFX_MSG_MAP(CStudentDoc)
	ON_COMMAND(ID_EDIT_CLEAR_ALL, OnEditClearAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_ALL, OnUpdateEditClearAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStudentDoc Konstruktion/Destruktion

CStudentDoc::CStudentDoc()
{
	TRACE("Eintritt in den Konstruktor von CStudentDoc\n");
#ifdef _DEBUG
	afxDump.SetDepth(1); // Speicherauszug soll Listenelemente erfassen
#endif // _DEBUG
}

CStudentDoc::~CStudentDoc()
{
}

BOOL CStudentDoc::OnNewDocument()
{
	TRACE("Eintritt CStudentDoc::OnNewDocument\n");
	if (!CDocument::OnNewDocument())
		return FALSE;

	// ZU ERLEDIGEN: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CStudentDoc Serialisierung

void CStudentDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// ZU ERLEDIGEN: Hier Code zum Speichern einfgen
	}
	else
	{
		// ZU ERLEDIGEN: Hier Code zum Laden einfgen
	}
}

/////////////////////////////////////////////////////////////////////////////
// CStudentDoc Diagnose

#ifdef _DEBUG
void CStudentDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CStudentDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
	dc << "\n" << m_studentList << "\n";
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CStudentDoc Befehle

void CStudentDoc::DeleteContents() 
{
#ifdef _DEBUG
	Dump(afxDump);
#endif
	while (m_studentList.GetHeadPosition()) {
		delete m_studentList.RemoveHead();
	}
}

void CStudentDoc::OnEditClearAll() 
{
	DeleteContents();
	UpdateAllViews(NULL);
}

void CStudentDoc::OnUpdateEditClearAll(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_studentList.IsEmpty());	
}

