// StudentView.h : Schnittstelle der Klasse CStudentView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_STUVIEW_H__54802EBE_CD0D_11D0_A42B_444553540000__INCLUDED_)
#define AFX_STUVIEW_H__54802EBE_CD0D_11D0_A42B_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CStudentView : public CFormView
{
protected:
	POSITION      m_position; // aktuelle Position in der Dokumentliste
	CStudentList* m_pList;    // aus Dokument kopiert

protected: // Nur aus Serialisierung erzeugen
	CStudentView();
	DECLARE_DYNCREATE(CStudentView)

public:
	//{{AFX_DATA(CStudentView)
	enum { IDD = IDD_STUDENT };
	int		m_nGrade;
	CString	m_strName;
	//}}AFX_DATA

// Attribute
public:
	CStudentDoc* GetDocument();

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CStudentView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CStudentView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void ClearEntry();
	virtual void InsertEntry(POSITION position);
	virtual void GetEntry(POSITION position);

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CStudentView)
	afx_msg void OnClear();
	afx_msg void OnCommandHome();
	afx_msg void OnCommandIns();
	afx_msg void OnCommandNext();
	afx_msg void OnCommandPrev();
	afx_msg void OnCommandEnd();
	afx_msg void OnCommandDel();
	afx_msg void OnUpdateCommandHome(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCommandEnd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCommandDel(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in StuView.cpp
inline CStudentDoc* CStudentView::GetDocument()
   { return (CStudentDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio fgt zustzliche Deklarationen unmittelbar vor der vorhergehenden Zeile ein.

#endif // !defined(AFX_STUVIEW_H__54802EBE_CD0D_11D0_A42B_444553540000__INCLUDED_)
