// ex19bView.cpp : Implementierung der Klasse CEx19bView
//

#include "stdafx.h"
#include "ex19b.h"

#include "ex19bDoc.h"
#include "ex19bView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx19bView

IMPLEMENT_DYNCREATE(CEx19bView, CView)

BEGIN_MESSAGE_MAP(CEx19bView, CView)
	//{{AFX_MSG_MAP(CEx19bView)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx19bView Konstruktion/Destruktion

CEx19bView::CEx19bView()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,

}

CEx19bView::~CEx19bView()
{
}

BOOL CEx19bView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CEx19bView Zeichnen

void CEx19bView::OnDraw(CDC* pDC)
{
	int i, j;

	CEx19bDoc* pDoc = GetDocument();
	j = pDoc->m_ellipseArray.GetUpperBound();
	for (i = 0; i < j; i++) {
		pDC->Ellipse(pDoc->m_ellipseArray[i]);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEx19bView Drucken

BOOL CEx19bView::OnPreparePrinting(CPrintInfo* pInfo)
{
	CEx19bDoc* pDoc = GetDocument();
	pInfo->SetMaxPage(pDoc->m_ellipseArray.GetUpperBound() /
		CEx19bDoc::nLinesPerPage + 1);
	return DoPreparePrinting(pInfo);
}

void CEx19bView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CEx19bView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Hier Bereinigungsarbeiten nach dem Drucken einfgen
}

/////////////////////////////////////////////////////////////////////////////
// CEx19bView Diagnose

#ifdef _DEBUG
void CEx19bView::AssertValid() const
{
	CView::AssertValid();
}

void CEx19bView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CEx19bDoc* CEx19bView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEx19bDoc)));
	return (CEx19bDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx19bView Nachrichten-Handler

void CEx19bView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	pDC->SetMapMode(MM_LOENGLISH);
}

void CEx19bView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	int        i, nStart, nEnd, nHeight;
	CString    str;
	CPoint     point(720, -1440);
	CFont      font;
	TEXTMETRIC tm;

	pDC->SetMapMode(MM_TWIPS);
	CEx19bDoc* pDoc = GetDocument();
	m_nPage = pInfo->m_nCurPage; // fr PrintPageFooter
	nStart = (m_nPage - 1) * CEx19bDoc::nLinesPerPage;
	nEnd = nStart + CEx19bDoc::nLinesPerPage;
	// 14-Punkt-Schrift mit festem Zeichenabstand
	font.CreateFont(-280, 0, 0, 0, 400, FALSE, FALSE,
	                0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
	                CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
	                DEFAULT_PITCH | FF_MODERN, "Courier New");
	                // Courier New ist eine TrueType-Schrift
	CFont* pOldFont = (CFont*) (pDC->SelectObject(&font));
	PrintPageHeader(pDC);
	pDC->GetTextMetrics(&tm);
	nHeight = tm.tmHeight + tm.tmExternalLeading;
	for (i = nStart; i < nEnd; i++) {
		if (i > pDoc->m_ellipseArray.GetUpperBound()) {
			break;
		}
		str.Format("%6d %6d %6d %6d %6d", i + 1,
		           pDoc->m_ellipseArray[i].left,
		           pDoc->m_ellipseArray[i].top,
		           pDoc->m_ellipseArray[i].right,
		           pDoc->m_ellipseArray[i].bottom);
		point.y -= nHeight;
		pDC->TextOut(point.x, point.y, str);
	}
	PrintPageFooter(pDC);
	pDC->SelectObject(pOldFont);
}

void CEx19bView::PrintPageHeader(CDC * pDC)
{
	CString str;

	CPoint point(0, 0);
	pDC->TextOut(point.x, point.y, "Position der Seifenblasen");
	point += CSize(720, -720);
	str.Format("%6.6s %6.6s %6.6s %6.6s %6.6s",
	           "Index", "Links", "Oben", "Rechts", "Unten");
	pDC->TextOut(point.x, point.y, str);
}

void CEx19bView::PrintPageFooter(CDC * pDC)
{
	CString str;

	CPoint point(0, -15840); // 10 Zoll nach unten gehen
	CEx19bDoc* pDoc = GetDocument();
	str.Format("Dokument %s", (LPCSTR) pDoc->GetTitle());
	pDC->TextOut(point.x, point.y, str);
	str.Format("Seite %d", m_nPage);
	CSize size = pDC->GetTextExtent(str);
	point.x += 11338 - size.cx;
	pDC->TextOut(point.x, point.y, str); // rechtsbndig
}
