// StringView.h : Schnittstelle der Klasse CStringView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_STRINGVIEW_H__45C4335D_4744_11D2_A4E4_00403394CA84__INCLUDED_)
#define AFX_STRINGVIEW_H__45C4335D_4744_11D2_A4E4_00403394CA84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LogScrollView.h"

class CStringView : public CLogScrollView
{
protected: // Nur aus Serialisierung erzeugen
	CStringView();
	DECLARE_DYNCREATE(CStringView)

// Attribute
public:
	CPoemDoc* GetDocument();

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CStringView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // das erste mal nach der Konstruktion aufgerufen
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CStringView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CStringView)
		// HINWEIS - An dieser Stelle werden Member-Funktionen vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CRect m_rectPrint;
};

#ifndef _DEBUG  // Testversion in StringView.cpp
inline CPoemDoc* CStringView::GetDocument()
   { return (CPoemDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_STRINGVIEW_H__45C4335D_4744_11D2_A4E4_00403394CA84__INCLUDED_)
