// ex25cDoc.cpp : Implementierung der Klasse CEx25cDoc
//

#include "stdafx.h"
#include "ex25c.h"

#include "Alarm.h"
#include "ex25cDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx25cDoc

IMPLEMENT_DYNCREATE(CEx25cDoc, CDocument)

BEGIN_MESSAGE_MAP(CEx25cDoc, CDocument)
	//{{AFX_MSG_MAP(CEx25cDoc)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CEx25cDoc, CDocument)
	//{{AFX_DISPATCH_MAP(CEx25cDoc)
	DISP_PROPERTY_NOTIFY(CEx25cDoc, "Time", m_time, OnTimeChanged, VT_DATE)
	DISP_FUNCTION(CEx25cDoc, "RefreshWin", Refresh, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CEx25cDoc, "ShowWin", ShowWin, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CEx25cDoc, "CreateAlarm", CreateAlarm, VT_DISPATCH, VTS_DATE)
	DISP_PROPERTY_PARAM(CEx25cDoc, "Figure", GetFigure, SetFigure, VT_VARIANT, VTS_I2)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Hinweis: Wir stellen Untersttzung fr IID_IEx25c zur Verfgung, um typsicheres Binden 
//  von VBA zu untersttzen. Diese IID muss mit der GUID bereinstimmen, die bei der 
//  Disp-Schnittstelle in der .ODL-Datei angegeben ist.

// {A9515B02-5B85-11D0-848F-00400526305B}
static const IID IID_IEx25c =
{ 0xa9515b02, 0x5b85, 0x11d0, { 0x84, 0x8f, 0x0, 0x40, 0x5, 0x26, 0x30, 0x5b } };

BEGIN_INTERFACE_MAP(CEx25cDoc, CDocument)
	INTERFACE_PART(CEx25cDoc, IID_IEx25c, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx25cDoc Konstruktion/Destruktion

CEx25cDoc::CEx25cDoc()
{
	// ZU ERLEDIGEN: Hier Code fr One-Time-Konstruktion einfgen
	
	TRACE("Eintritt CEx25cDoc ctor\n");
	m_time = COleDateTime(0, 0, 0, 5, 10, 15);
	// Initialisierung mit Dummy-Werten
	m_strFigure[0] = "XII"; m_strFigure[1] = "III";
	m_strFigure[2] = "VI"; m_strFigure[3] = "IX";
	m_pAlarm = NULL;


	EnableAutomation();

	AfxOleLockApp();
}

CEx25cDoc::~CEx25cDoc()
{
	AfxOleUnlockApp();
}

BOOL CEx25cDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// ZU ERLEDIGEN: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CEx25cDoc Serialisierung

void CEx25cDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// ZU ERLEDIGEN: Hier Code zum Speichern einfgen
	}
	else
	{
		// ZU ERLEDIGEN: Hier Code zum Laden einfgen
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEx25cDoc Diagnose

#ifdef _DEBUG
void CEx25cDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CEx25cDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx25cDoc Befehle

BOOL CEx25cDoc::SaveModified() 
{
	// TODO: Speziellen Code hier einfgen und/oder Basisklasse aufrufen
	
	return CDocument::SaveModified();
}

void CEx25cDoc::OnTimeChanged() 
{
	// ZU ERLEDIGEN: Code fr Behandlungsroutine der Benachrichtigung hinzufgen

}



VARIANT CEx25cDoc::GetFigure(short n) 
{
	TRACE("Eintritt CEx25cDoc::GetFigure -- n = %d m_strFigure[n] = %s\n",
           n, m_strFigure[n]);
	return COleVariant(m_strFigure[n]).Detach();
}

void CEx25cDoc::SetFigure(short n, const VARIANT FAR& newValue) 
{
	TRACE("Eintritt CEx25cDoc::SetFigure -- n = %d, vt = %d\n", n, 
		   newValue.vt);
	COleVariant vaTemp;
	vaTemp.ChangeType(VT_BSTR, (COleVariant*) &newValue);
	m_strFigure[n] = vaTemp.bstrVal; // konvertiert Breitzeichen in einfache Zeichen
}

void CEx25cDoc::ShowWin() 
{
	TRACE("Entering CEx25cDoc::ShowWin\n");
	CRect rectWindow;
	CWnd* pFrm = AfxGetApp()->m_pMainWnd;
	pFrm->GetWindowRect(rectWindow);
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	wndpl.showCmd = SW_SHOWNORMAL;
	wndpl.rcNormalPosition.left = rectWindow.left;
	wndpl.rcNormalPosition.top = rectWindow.top;
	wndpl.rcNormalPosition.right = rectWindow.left + 150;
	wndpl.rcNormalPosition.bottom = rectWindow.top + 150;
	pFrm->SetWindowPlacement(&wndpl);
	pFrm->ShowWindow(AfxGetApp()->m_nCmdShow);
	pFrm->UpdateWindow();
	pFrm->BringWindowToTop();
}

LPDISPATCH CEx25cDoc::CreateAlarm(DATE time) 
{
	TRACE("Eintritt CEx25cDoc::CreateAlarm, time = %f\n", time);
	// OLE lscht alle zuvor vorhandenen CAlarm-Objekte
	m_pAlarm = new CAlarm(time);
	return m_pAlarm->GetIDispatch(FALSE);   // kein Aufruf von AddRef
}

void CEx25cDoc::Refresh() 
{
	TRACE("Eintritt CEx25cDoc::Refresh\n");
	UpdateAllViews(NULL);  // Erklrt die einzige Ansicht fr ungltig
//	AfxGetApp()->m_pMainWnd->BringWindowToTop();
}
