// ex26bView.h : Schnittstelle der Klasse CEx26bView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EX26BVIEW_H__8077DAA1_4C87_11D2_A4E4_00403394CA84__INCLUDED_)
#define AFX_EX26BVIEW_H__8077DAA1_4C87_11D2_A4E4_00403394CA84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CEx26bView : public CScrollView
{
// Fr Begrenzungsrechteck
    CRectTracker m_tracker;
    CRect m_rectTracker;
// Fr Drag-&-Drop-Operationen
    CRect m_rectTrackerEnter; // logische Koordinaten
    COleDropTarget m_dropTarget;
    CSize m_dragOffset; // Gertekoordinaten

    CSize m_sizeTotal;  // Dokumentengre
protected: // Nur aus Serialisierung erzeugen
	CEx26bView();
	DECLARE_DYNCREATE(CEx26bView)

// Attribute
public:
	CEx26bDoc* GetDocument();

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CEx26bView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate(); // das erste mal nach der Konstruktion aufgerufen
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CEx26bView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CEx26bView)
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCopyto();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditPastefrom();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
    BOOL DoPasteDib(COleDataObject* pDataObject);
    COleDataSource* SaveDib();
    void MoveTrackRect(CPoint point);
};

#ifndef _DEBUG  // Testversion in ex26bView.cpp
inline CEx26bDoc* CEx26bView::GetDocument()
   { return (CEx26bDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_EX26BVIEW_H__8077DAA1_4C87_11D2_A4E4_00403394CA84__INCLUDED_)
