// EX35A.H - Header-Datei fr den Internet Server
//    ex35a-Erweiterung

#include "resource.h"

class CEx35aExtension : public CHttpServer
{
public:
	CEx35aExtension();
	~CEx35aExtension();
private:
	CCriticalSection m_cs;
	int m_nTotalPizzaOrders;

// berladungen
		// HINWEIS - An dieser Stelle werden Member-Funktionen vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//{{AFX_VIRTUAL(CEx35aExtension)
	public:
	virtual BOOL GetExtensionVersion(HSE_VERSION_INFO* pVer);
	virtual LPCTSTR GetTitle() const;
	//}}AFX_VIRTUAL

	// ZU ERLEDIGEN: Handler fr Befehle hier einfgen
	// Zum Beispiel:

	void Default(CHttpServerContext* pCtxt);
	void ConfirmOrder(CHttpServerContext* pCtxt, LPCTSTR pstrName);
	void ProcessPizzaForm(CHttpServerContext* pCtxt, LPCTSTR pstrName, LPCTSTR pstrAddr, int nQuantity,
			LPCTSTR pstrSize, LPCTSTR pstrTop1, LPCTSTR pstrTop2, LPCTSTR pstrTop3, LPCTSTR pstrTop4);
	void ProcessTimesheet(CHttpServerContext* pCtxt, int nPeriod, LPCTSTR pstrEmployee,
			double dHours, int nJob);

	DECLARE_PARSE_MAP()

	//{{AFX_MSG(CEx35aExtension)
	//}}AFX_MSG
};

