// urlthread.cpp

#include <stdafx.h>
#include "urlthread.h"
#define MAXBUF 100

CString g_strURL = "http://";
volatile BOOL g_bThreadStarted = FALSE;
CEvent g_eKill;

UINT UrlThreadProc(LPVOID pParam)
{
	g_bThreadStarted = TRUE;
	CString strLine;
	CInternetSession session;
	CStdioFile* pFile1 = NULL;

	try {
		pFile1 = session.OpenURL(g_strURL, 0, INTERNET_FLAG_TRANSFER_BINARY |
				INTERNET_FLAG_KEEP_CONNECTION); // Fr Windows NT-Echtheitsprfung erforderlich
		// Text des URL anzeigen, bis Kill-Ereignis empfangen wird
		while(::WaitForSingleObject(g_eKill.m_hObject, 0) != WAIT_OBJECT_0) {
			// Zeilenweise bertragen
			if(pFile1->ReadString(strLine) == FALSE) break;
			strLine += '\n';
			::SendMessage((HWND) pParam, EM_SETSEL, (WPARAM) 999999, 1000000);
			::SendMessage((HWND) pParam, EM_REPLACESEL, (WPARAM) 0,
						(LPARAM) (const char*) strLine);
			Sleep(250); // Transfer verlangsamen
		}
	}
	catch(CInternetException* e) {
		LogInternetException(pParam, e);
		e->Delete();
	}
	if(pFile1 != NULL) delete pFile1; // Datei schlieen - Warnung ausgeben
	g_bThreadStarted = FALSE;
	// Nachrichten zur Aktualisierung der Symbolleiste senden
	::PostMessage((HWND) pParam, EM_SETSEL, (WPARAM) 999999, 1000000);
	TRACE("Post-Thread wird normal beendet\n");
	return 0;
}

void LogInternetException(LPVOID pParam, CInternetException* pe)
{	
	CString strGmt = CTime::GetCurrentTime().FormatGmt("%m/%d/%y %H:%M:% GMT");
	char text1[300], text2[100];
	wsprintf(text1, "\r\nERROR: WinInet-Fehler #%d -- %s\r\n   ",
		pe->m_dwError, (const char*) strGmt);
	pe->GetErrorMessage(text2, 99);
	strcat(text1, text2);
	if(pe->m_dwError == 12152) {
		strcat(text1, "  URL nicht gefunden?\r\n");
	}
	::SendMessage((HWND) pParam, EM_SETSEL, (WPARAM) 999999, 1000000);
	::SendMessage((HWND) pParam, EM_REPLACESEL, (WPARAM) 0, (LPARAM) text1);
}
