// StuDoc.h : Schnittstelle der Klasse CStudentDoc
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_STUDOC_H__54802EBC_CD0D_11D0_A42B_444553540000__INCLUDED_)
#define AFX_STUDOC_H__54802EBC_CD0D_11D0_A42B_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "student.h"

class CStudentDoc : public CDocument
{
protected: // Nur aus Serialisierung erzeugen
	CStudentDoc();
	DECLARE_DYNCREATE(CStudentDoc)

// Attribute
public:
	CStudentList* GetList() {
		return &m_studentList;
	}

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CStudentDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CStudentDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CStudentDoc)
	afx_msg void OnEditClearAll();
	afx_msg void OnUpdateEditClearAll(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CStudentList m_studentList;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio fgt zustzliche Deklarationen unmittelbar vor der vorhergehenden Zeile ein.

#endif // !defined(AFX_STUDOC_H__54802EBC_CD0D_11D0_A42B_444553540000__INCLUDED_)
