#if !defined(AFX_RYGWND_H__B045FC75_47F2_11D2_A4E4_00403394CA84__INCLUDED_)
#define AFX_RYGWND_H__B045FC75_47F2_11D2_A4E4_00403394CA84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RygWnd.h : Header-Datei
//

/////////////////////////////////////////////////////////////////////////////
// Fenster CRygWnd 

#define RYG_SETSTATE WM_USER + 0
#define RYG_GETSTATE WM_USER + 1

LRESULT CALLBACK AFX_EXPORT
	RygWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

class CRygWnd : public CWnd
{
	private:
	int m_nState; // 0=aus, 1=rot, 2=gelb, 3=grn
	static CRect  s_rect;
	static CPoint s_point;
	static CRect  s_rColor[3];
	static CBrush s_bColor[4];

// Konstruktion
public:
	CRygWnd();
public:
	static BOOL RegisterWndClass(HINSTANCE hInstance);
// Attribute
public:

// Operationen
public:

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CRygWnd)
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CRygWnd();

	// Generierte Nachrichtenzuordnungsfunktionen
	private:
	void SetMapping(CDC* pDC);
	void UpdateColor(CDC* pDC, int n);
protected:
	//{{AFX_MSG(CRygWnd)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	//}}AFX_MSG
	afx_msg LRESULT OnSetState(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnGetState(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_RYGWND_H__B045FC75_47F2_11D2_A4E4_00403394CA84__INCLUDED_
