// CEx25bAuto.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "ex25b.h"
#include "ex25bAuto.h"
#include "Promptdl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx25bAuto

IMPLEMENT_DYNCREATE(CEx25bAuto, CCmdTarget)

CEx25bAuto::CEx25bAuto()
{
	EnableAutomation();
	
	// Um die Ausfhrung der Anwendung fortzusetzen, solange ein OLE-Automatisierungs
	//	objekt aktiv ist, ruft der Konstruktor AfxOleLockApp auf.
    
	::VariantInit(&m_vaTextData); // erforderliche Initialisierung
    m_lData = 0;
		
	AfxOleLockApp();
}

CEx25bAuto::~CEx25bAuto()
{
	// Um die Anwendung zu beenden, nachdem alle Objekte durch OLE-Automatisierung
	// 	erstellt wurden, ruft der Destruktor AfxOleUnlockApp auf.
	
	AfxOleUnlockApp();
}


void CEx25bAuto::OnFinalRelease()
{
	// Nachdem die letzte Referenz auf ein Automatisierungsobjekt freigegeben wurde,
	// wird OnFinalRelease aufgerufen. Die Basisklasse lscht das Objekt
	// automatisch. Fgen Sie zustzlichen Bereinigungscode fr Ihr Objekt
	// hinzu, bevor Sie die Basisklasse aufrufen.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CEx25bAuto, CCmdTarget)
	//{{AFX_MSG_MAP(CEx25bAuto)
		// HINWEIS - Der Klassen-Assistent fgt hier Zuordnungsmakros ein und entfernt diese.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CEx25bAuto, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CEx25bAuto)
	DISP_PROPERTY_NOTIFY(CEx25bAuto, "TextData", m_vaTextData, OnTextDataChanged, VT_VARIANT)
	DISP_PROPERTY_NOTIFY(CEx25bAuto, "LongData", m_lData, OnLongDataChanged, VT_I4)
	DISP_FUNCTION(CEx25bAuto, "DisplayDialog", DisplayDialog, VT_BOOL, VTS_NONE)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Hinweis: Wir stellen Untersttzung fr IID_IEx25bAuto zur Verfgung, um typsicheres Binden
//  von VBA zu ermglichen. Diese IID muss mit der GUID bereinstimmen, die in der
//  Disp-Schnittstelle in der .ODL-Datei angegeben ist.

// {A9515AD7-5B85-11D0-848F-00400526305B}
static const IID IID_IEx25bAuto =
{ 0xa9515ad7, 0x5b85, 0x11d0, { 0x84, 0x8f, 0x0, 0x40, 0x5, 0x26, 0x30, 
    0x5b } };

BEGIN_INTERFACE_MAP(CEx25bAuto, CCmdTarget)
	INTERFACE_PART(CEx25bAuto, IID_IEx25bAuto, Dispatch)
END_INTERFACE_MAP()

// {A9515AD8-5B85-11D0-848F-00400526305B}
IMPLEMENT_OLECREATE(CEx25bAuto, "ex25b.Auto", 0xa9515ad8, 0x5b85, 
    0x11d0, 0x84, 0x8f, 0x0, 0x40, 0x5, 0x26, 0x30, 0x5b)

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CEx25bAuto 

BOOL CEx25bAuto::DisplayDialog() 
{
 TRACE("Eintritt: CEx25bAuto::DisplayDialog %p\n", this);
    BOOL bRet = TRUE;
    AfxLockTempMaps();  // Siehe MFC Tech Note #3
    CWnd* pTopWnd = CWnd::FromHandle(::GetTopWindow(NULL));
    try {
      CPromptDlg dlg(pTopWnd);
      if (m_vaTextData.vt == VT_BSTR){
        dlg.m_strData = m_vaTextData.bstrVal; // 2 Byte lange Zeichen werden in
                                              // 1 Byte lange Zeichen umgewandelt
		                                                                                                                                                        
      }
      dlg.m_lData = m_lData;
      if (dlg.DoModal() == IDOK) {
        m_vaTextData = COleVariant(dlg.m_strData).Detach();
        m_lData = dlg.m_lData;
        bRet = TRUE;
      }
      else {
        bRet =  FALSE;
      }
    }
    catch (CException* pe) {
      TRACE("Ausnahme ausgelst: Dialog kann nicht angezeigt werden\n");
      bRet =  FALSE;
	  pe->Delete();
    }
    AfxUnlockTempMaps();
    return bRet;
}


void CEx25bAuto::OnTextDataChanged() 
{
	TRACE("CEx25bAuto::OnTextDataChanged\n");

}


void CEx25bAuto::OnLongDataChanged() 
{
  TRACE("CEx25bAuto::OnLDataChanged\n");
}
