// ex25dView.h : Schnittstelle der Klasse CEx25dView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EX25dVIEW_H__A9515B22_5B85_11D0_848F_00400526305B__INCLUDED_)
#define AFX_EX25dVIEW_H__A9515B22_5B85_11D0_848F_00400526305B__INCLUDED_


#include "AutoDriver.h"
#include "BankDriver.h"
#include "ClockDriver.h"
#include "excel8.h"

#include "AlarmDialog.h"

class CEx25dView : public CView
{
private:
   IAlarm m_alarm;
   IEx25bAuto m_auto;
   IBank m_bank;
   IEx25c m_clock;
   
   _Application m_app;
   Range    m_range[5];
   _Worksheet   m_worksheet;
   Workbooks   m_workbooks;
   Worksheets   m_worksheets;
   
protected: // Nur aus Serialisierung erzeugen
   CEx25dView();
   DECLARE_DYNCREATE(CEx25dView)

// Attribute
public:
   CEx25dDoc* GetDocument();

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
  //{{AFX_VIRTUAL(CEx25dView)
   public:
   virtual void OnDraw(CDC* pDC);  //berladen zum Zeichnen dieser Ansicht
   virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
   protected:
   //}}AFX_VIRTUAL

// Implementierung
public:
   virtual ~CEx25dView();
#ifdef _DEBUG
   virtual void AssertValid() const;
   virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
   //{{AFX_MSG(CEx25dView)
   afx_msg void OnBankoleLoad();
   afx_msg void OnUpdateBankoleLoad(CCmdUI* pCmdUI);
   afx_msg void OnBankoleTest();
   afx_msg void OnUpdateBankoleTest(CCmdUI* pCmdUI);
   afx_msg void OnBankoleUnload();
   afx_msg void OnUpdateBankoleUnload(CCmdUI* pCmdUI);
   afx_msg void OnClockoleCreatealarm();
   afx_msg void OnUpdateClockoleCreatealarm(CCmdUI* pCmdUI);
   afx_msg void OnClockoleLoad();
   afx_msg void OnUpdateClockoleLoad(CCmdUI* pCmdUI);
   afx_msg void OnClockoleRefreshtime();
   afx_msg void OnUpdateClockoleRefreshtime(CCmdUI* pCmdUI);
   afx_msg void OnClockoleUnload();
   afx_msg void OnUpdateClockoleUnload(CCmdUI* pCmdUI);
   afx_msg void OnDlloleGetdata();
   afx_msg void OnUpdateDlloleGetdata(CCmdUI* pCmdUI);
   afx_msg void OnDlloleLoad();
   afx_msg void OnUpdateDlloleLoad(CCmdUI* pCmdUI);
   afx_msg void OnDlloleUnload();
   afx_msg void OnUpdateDlloleUnload(CCmdUI* pCmdUI);
   afx_msg void OnExceloleExecute();
   afx_msg void OnUpdateExceloleExecute(CCmdUI* pCmdUI);
   afx_msg void OnExceloleLoad();
   afx_msg void OnUpdateExceloleLoad(CCmdUI* pCmdUI);
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in ex25dView.cpp
inline CEx25dDoc* CEx25dView::GetDocument()
   { return (CEx25dDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_EX25dVIEW_H__A9515B22_5B85_11D0_848F_00400526305B__INCLUDED_)
