// ex26aView.h : Schnittstelle der Klasse CEx26aView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EX26AVIEW_H__8077DA8D_4C87_11D2_A4E4_00403394CA84__INCLUDED_)
#define AFX_EX26AVIEW_H__8077DA8D_4C87_11D2_A4E4_00403394CA84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WM_VIEWPALETTECHANGED	WM_USER + 5

class CEx26aView : public CScrollView
{
    // zur Erfassung des Bildlaufs
    CRectTracker m_tracker;
    CRect m_rectTracker; // logische Koordinaten
    CSize m_sizeTotal;   // Dokumentgre
protected: // Nur aus Serialisierung erzeugen
	CEx26aView();
	DECLARE_DYNCREATE(CEx26aView)

// Attribute
public:
	CEx26aDoc* GetDocument();

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CEx26aView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual void OnInitialUpdate(); // das erste Mal nach der Konstruktion aufgerufen
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CEx26aView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CEx26aView)
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCopyto();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditPastefrom();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg LONG OnViewPaletteChanged(UINT wParam, LONG lParam);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	BOOL DoPasteDib(COleDataObject* pDataObject);
	COleDataSource* SaveDib();
};

#ifndef _DEBUG  // Testversion in ex26aView.cpp
inline CEx26aDoc* CEx26aView::GetDocument()
   { return (CEx26aDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_EX26AVIEW_H__8077DA8D_4C87_11D2_A4E4_00403394CA84__INCLUDED_)
