// ex28aDoc.cpp : Implementierung der Klasse CEx28aDoc
//

#include "stdafx.h"
#include "ex28a.h"

#include "ex28aDoc.h"
#include "SrvrItem.h"
#include "TextDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx28aDoc

IMPLEMENT_DYNCREATE(CEx28aDoc, COleServerDoc)

BEGIN_MESSAGE_MAP(CEx28aDoc, COleServerDoc)
	//{{AFX_MSG_MAP(CEx28aDoc)
	ON_COMMAND(ID_MODIFY, OnModify)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx28aDoc Konstruktion/Destruktion

CEx28aDoc::CEx28aDoc()
{
	// Verwenden Sie OLE-Compound-Dateien
	EnableCompoundFile();

	// ZU ERLEDIGEN: Hier Code fr One-Time-Konstruktion einfgen

}

CEx28aDoc::~CEx28aDoc()
{
}

BOOL CEx28aDoc::OnNewDocument()
{
	if (!COleServerDoc::OnNewDocument())
		return FALSE;

	m_strText = "Standardtext";

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CEx28aDoc Server-Implementierung

COleServerItem* CEx28aDoc::OnGetEmbeddedItem()
{
	// OnGetEmbeddedItem wird automatisch aufgerufen, um COleServerItem zu erhalten,
	//  das mit dem Dokument verknpft ist. Die Funktion wird nur bei Bedarf aufgerufen.

	CEx28aSrvrItem* pItem = new CEx28aSrvrItem(this);
	ASSERT_VALID(pItem);
	return pItem;
}



/////////////////////////////////////////////////////////////////////////////
// CEx28aDoc Serialisierung

void CEx28aDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_strText;
	}
	else
	{
		ar >> m_strText;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEx28aDoc Diagnose

#ifdef _DEBUG
void CEx28aDoc::AssertValid() const
{
	COleServerDoc::AssertValid();
}

void CEx28aDoc::Dump(CDumpContext& dc) const
{
	COleServerDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx28aDoc Befehle

void CEx28aDoc::OnModify() 
{
CTextDialog dlg;
    dlg.m_strText = m_strText;
    if (dlg.DoModal() == IDOK) {
        m_strText = dlg.m_strText;
        UpdateAllViews(NULL); //  CEx28aView::OnDraw aufrufen
        UpdateAllItems(NULL); //  CEx28aSrvrItem::OnDraw aufrufen
        SetModifiedFlag();
    }
	
	
}
