// ex28bView.h : Schnittstelle der Klasse CEx28bView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EX28BVIEW_H__0798C692_4D79_11D2_A4E4_00403394CA84__INCLUDED_)
#define AFX_EX28BVIEW_H__0798C692_4D79_11D2_A4E4_00403394CA84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define CF_OBJECTDESCRIPTOR	"Object Descriptor"
#define CF_EMBEDDEDOBJECT "Embedded Object"
#define SETFORMATETC(fe, cf, asp, td, med, li)   \
	((fe).cfFormat=cf, \
	 (fe).dwAspect=asp, \
	 (fe).ptd=td, \
	 (fe).tymed=med, \
	 (fe).lindex=li)

/////////////////////////////////////////////////////////////////////////////
class CEx28bView : public CScrollView
{
public:
	CLIPFORMAT m_cfObjDesc;
	CLIPFORMAT m_cfEmbedded;
	CSize m_sizeTotal;   // Dokumentgre
	CRectTracker m_tracker;
	CRect m_rectTracker; // logische Koordinaten
protected: // Nur aus Serialisierung erzeugen
	CEx28bView();
	DECLARE_DYNCREATE(CEx28bView)

// Attribute
public:
	CEx28bDoc* GetDocument();

private:
	void GetSize();
	void SetNames();
	void SetViewAdvise();
	BOOL MakeMetafilePict(COleDataSource* pSource);
	COleDataSource* SaveObject();
	BOOL DoPasteObject(COleDataObject* pDataObject);
	BOOL DoPasteObjectDescriptor(COleDataObject* pDataObject);

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CEx28bView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate(); 
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CEx28bView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CEx28bView)
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCopyto();
	afx_msg void OnEditCut();
	afx_msg void OnEditInsertobject();
	afx_msg void OnUpdateEditInsertobject(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditPastefrom();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in ex28bView.cpp
inline CEx28bDoc* CEx28bView::GetDocument()
   { return (CEx28bDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_EX28BVIEW_H__0798C692_4D79_11D2_A4E4_00403394CA84__INCLUDED_)
