// ex31dvw.h : Schnittstelle der Klasse CEx31dView
//
/////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_EX31DVIEW_H__BA9E33F2_958A_11D0_AAA2_444553540000__INCLUDED_)
#define AFX_EX31DVIEW_H__BA9E33F2_958A_11D0_AAA2_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "rowview.h"

class CEx31dView : public CRowView
{
private:
	int m_nSelectedRow;
	CRecordset* m_pSet;
protected: // Nur aus Serialisierung erzeugen
	CEx31dView();
	DECLARE_DYNCREATE(CEx31dView)

// Attribute
public:
	CEx31dDoc* GetDocument();
	//{{AFX_VIRTUAL(CEx31dView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView*, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL


// berschreibungen von CRowView
	void OnDrawRow(CDC* pDC, int nRowNo, int y, BOOL bSelected);
	void GetRowWidthHeight(CDC* pDC, int& nRowWidth, 
		int& nRowHeight, int& nCharWidth);
	int GetActiveRow();
	int GetRowCount();
	void ChangeSelectionNextRow(BOOL bNext);
	void ChangeSelectionToRow(int nRow);

// Implementierung
public:
	virtual ~CEx31dView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
private:
	void DrawDataRow(CDC* pDC, int y);
// Generated message map functions
protected:
	//{{AFX_MSG(CEx31dView)
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg int OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in ex31dView.cpp
inline CEx31dDoc* CEx31dView::GetDocument()
   { return (CEx31dDoc*) m_pDocument; }
#endif
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_EX31DVIEW_H__BA9E33F2_958A_11D0_AAA2_444553540000__INCLUDED_)
