// ex32avw.h : Schnittstelle der Klasse CEx32aView
//
/////////////////////////////////////////////////////////////////////////////
#include "RowView.h"

#if !defined(AFX_EX32AVIEW_H__87130E7F_8817_11D0_86C5_F5A2C72DE570__INCLUDED_)
#define AFX_EX32AVIEW_H__87130E7F_8817_11D0_86C5_F5A2C72DE570__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CEx32aView : public CRowView
{
private:
	int m_nSelectedRow;
	CDaoRecordset* m_pSet;
protected: // Nur aus Serialisierung erzeugen
	CEx32aView();
	DECLARE_DYNCREATE(CEx32aView)

// Attribute
public:
	CEx32aDoc* GetDocument();
	//{{AFX_VIRTUAL(CEx32aView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView*, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL


// berschreibungen von CRowView
	void OnDrawRow(CDC* pDC, int nRowNo, int y, BOOL bSelected);
	void GetRowWidthHeight(CDC* pDC, int& nRowWidth, 
		int& nRowHeight, int& nCharWidth);
	int GetActiveRow();
	int GetRowCount();
	void ChangeSelectionNextRow(BOOL bNext);
	void ChangeSelectionToRow(int nRow);

// Implementierung
public:
	virtual ~CEx32aView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
private:
	void DrawDataRow(CDC* pDC, int y);
// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CEx32aView)
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg int OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG	// Testversion in ex32avw.cpp
inline CEx32aDoc* CEx32aView::GetDocument()
   { return (CEx32aDoc*) m_pDocument; }
#endif
/////////////////////////////////////////////////////////////////////////////


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_EX32AVIEW_H__87130E7F_8817_11D0_86C5_F5A2C72DE570__INCLUDED_)
