// clienturlthread.cpp (verwendet CInternetSession::OpenURL)

#include <stdafx.h>
#include "utility.h"
#define MAXBUF 50000

CString g_strURL = "http://";

UINT ClientUrlThreadProc(LPVOID pParam)
{
	char* buffer = new char[MAXBUF];
	UINT nBytesRead = 0;

	CInternetSession session; // Keine Status-Callbacks fr OpenURL
	CStdioFile* pFile1 = NULL; // ber ReadString eine Zeile lesen
	try {
		pFile1 = session.OpenURL(g_strURL, 0, INTERNET_FLAG_TRANSFER_BINARY |
				INTERNET_FLAG_KEEP_CONNECTION);
		// Wenn OpenURL fehlschlgt, kommen wir ber diesen Punkt nicht hinaus
		nBytesRead = pFile1->Read(buffer, MAXBUF - 1);
		buffer[nBytesRead] = '\0'; // fr Meldungsfeld erforderlich
		char temp[100];
		if(pFile1->Read(temp, 100) != 0) { // Ermglicht Caching nach Abschluss des Lesevorgangs
			AfxMessageBox("File overran buffer -- not cached");
		}
		::MessageBox(::GetTopWindow(::GetDesktopWindow()), buffer, "URL CLIENT", MB_OK);
	}
	catch(CInternetException* e) {
		LogInternetException(pParam, e);
		e->Delete();
	}
	if(pFile1) delete pFile1;
	delete [] buffer;
	return 0;
}
