// IpFrame.cpp : Implementierung der Klasse CInPlaceFrame
//

#include "stdafx.h"
#include "ex36a.h"

#include "urlthread.h"
#include "IpFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInPlaceFrame

IMPLEMENT_DYNCREATE(CInPlaceFrame, COleDocIPFrameWnd)

BEGIN_MESSAGE_MAP(CInPlaceFrame, COleDocIPFrameWnd)
	//{{AFX_MSG_MAP(CInPlaceFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInPlaceFrame Konstruktion/Destruktion

CInPlaceFrame::CInPlaceFrame()
{
}

CInPlaceFrame::~CInPlaceFrame()
{
}

int CInPlaceFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (COleDocIPFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// CResizeBar implementiert direkte Grennderungen.
	if (!m_wndResizeBar.Create(this))
	{
		TRACE0("Leiste fr Grennderung konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	// Allgemein ist es von Vorteil, ein Drop-Ziel zu registrieren, das
	//  keinerlei Auswirkung auf Ihr Rahmenfenster hat. Dies verhindert bei Drops ("Abwrfen")
	// ein "Durchfallen" zu einem Container, der Drag and Drop untersttzt.
	m_dropTarget.Register(this);

	return 0;
}

// OnCreateControlBars wird automatisch aufgerufen, um Steuerleisten im Fenster der
//  Container-Anwendung zu erstellen. pWndFrame ist das hierarchisch hchste Rahmenfenster des
//  Containers und ist immer ungleich NULL. pWndDoc ist das Rahmenfenster auf Dokumentebene
//  und ist gleich NULL, wenn der Container eine SDI-Anwendung ist. Eine Server
//  Anwendung kann MFC-Steuerelementleisten in jedes Fenster platzieren.
BOOL CInPlaceFrame::OnCreateControlBars(CFrameWnd* pWndFrame, CFrameWnd* pWndDoc)
{
	m_wndDialogBar.SetOwner(this); // fr Befehle
	if (!m_wndDialogBar.Create(pWndFrame, IDD_DIALOGBAR, CBRS_TOP, 0xE810))
	{
		TRACE0("Dialogleiste konnte nicht erstellt werden\n");
		return -1;      // fail to create
	}
	m_wndDialogBar.SetDlgItemText(IDC_URL, g_strURL);
	// Bitmaps den Schaltflchen der Dialogleiste zuordnen
	m_bitmapGreen.LoadBitmap(IDB_GREEN);
	HBITMAP hBitmap = (HBITMAP) m_bitmapGreen.GetSafeHandle();
	((CButton*) m_wndDialogBar.GetDlgItem(IDC_START))->SetBitmap(hBitmap);
	m_bitmapRed.LoadBitmap(IDB_RED);
	hBitmap = (HBITMAP) m_bitmapRed.GetSafeHandle();
	((CButton*) m_wndDialogBar.GetDlgItem(IDC_STOP))->SetBitmap(hBitmap);

	return TRUE;
}

BOOL CInPlaceFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return COleDocIPFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CInPlaceFrame Diagnose

#ifdef _DEBUG
void CInPlaceFrame::AssertValid() const
{
	COleDocIPFrameWnd::AssertValid();
}

void CInPlaceFrame::Dump(CDumpContext& dc) const
{
	COleDocIPFrameWnd::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CInPlaceFrame Befehle
