// ex36aView.cpp : Implementierung der Klasse CEx36aView
//

#include "stdafx.h"
#include "ex36a.h"

#include "ex36aDoc.h"
#include "CntrItem.h"
#include "ex36aView.h"
#include "UrlThread.h"
#include "MainFrm.h"
#include "IpFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx36aView

IMPLEMENT_DYNCREATE(CEx36aView, CRichEditView)

BEGIN_MESSAGE_MAP(CEx36aView, CRichEditView)
	//{{AFX_MSG_MAP(CEx36aView)
	ON_COMMAND(ID_CANCEL_EDIT_SRVR, OnCancelEditSrvr)
	ON_COMMAND(ID_EDIT_CLEAR_ALL, OnEditClearAll)
	ON_COMMAND(IDC_START, OnStart)
	ON_UPDATE_COMMAND_UI(IDC_START, OnUpdateStart)
	ON_COMMAND(IDC_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(IDC_STOP, OnUpdateStop)
//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRichEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEx36aView Konstruktion/Destruktion

CEx36aView::CEx36aView()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,

}

CEx36aView::~CEx36aView()
{
}

BOOL CEx36aView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CRichEditView::PreCreateWindow(cs);
}

void CEx36aView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();


	// Druckrnder festlegen (720 Twips = 1/2 Zoll).
	SetMargins(CRect(720, 720, 720, 720));
}

/////////////////////////////////////////////////////////////////////////////
// CEx36aView Drucken

BOOL CEx36aView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}


/////////////////////////////////////////////////////////////////////////////
// OLE-Server-Untersttzung

// Der folgende Befehls-Handler stellt die Standardtastatur als
//  Benutzerschnittstelle zum Abbruch der direkten Bearbeitungssitzung zur Verfgung. Hier
//  verursacht der Container (nicht der Server) die Deaktivierung.
void CEx36aView::OnCancelEditSrvr()
{
	GetDocument()->OnDeactivateUI(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// CEx36aView Diagnose

#ifdef _DEBUG
void CEx36aView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CEx36aView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CEx36aDoc* CEx36aView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEx36aDoc)));
	return (CEx36aDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEx36aView Nachrichten-Handler

void CEx36aView::OnEditClearAll() 
{
	SetWindowText("");
}

void CEx36aView::OnStart() 
{
	CWnd* pFrm = GetParent(); // nur SDI
	CWnd* pBar;
	if(pFrm->IsKindOf(RUNTIME_CLASS(CMainFrame))) {
		pBar = &((CMainFrame*) pFrm)->m_wndDialogBar;
	}
	else {
		pBar = &((CInPlaceFrame*) pFrm)->m_wndDialogBar;
	}
	// g_strURL: Thread synchronisiert?
	pBar->GetDlgItemText(IDC_URL, g_strURL);
	TRACE("CEx36aView::OnRequest -- URL = %s\n", g_strURL);
	AfxBeginThread(UrlThreadProc, GetSafeHwnd(), THREAD_PRIORITY_NORMAL);
}

void CEx36aView::OnStop() 
{
	g_eKill.SetEvent();
}

void CEx36aView::OnUpdateStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(g_bThreadStarted);
}

void CEx36aView::OnUpdateStart(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!g_bThreadStarted);
}

