// CntrItem.cpp : Implementierung der Klasse CEx36bCntrItem
//

#include "stdafx.h"
#include "ex36b.h"

#include "ex36bDoc.h"
#include "ex36bView.h"
#include "CntrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEx36bCntrItem Implementierung

IMPLEMENT_SERIAL(CEx36bCntrItem, COleClientItem, 0)

CEx36bCntrItem::CEx36bCntrItem(CEx36bDoc* pContainer)
	: COleClientItem(pContainer)
{
	// ZU ERLEDIGEN: Hier Code fr One-Time-Konstruktion einfgen
	
}

CEx36bCntrItem::~CEx36bCntrItem()
{
	// ZU ERLEDIGEN: Hier Bereinigungscode hinzufgen
	
}

void CEx36bCntrItem::OnChange(OLE_NOTIFICATION nCode, DWORD dwParam)
{
	ASSERT_VALID(this);

	COleClientItem::OnChange(nCode, dwParam);

	// Wird ein Element bearbeitet (entweder direkt oder voll geffnet),
	//  sendet es OnChange-Benachrichtigungen fr nderungen im Status des
	//  Elements oder im visuellen Erscheinungsbild seines Inhalts.

	// ZU ERLEDIGEN: Element ungltig machen, indem Sie UpdateAllViews aufrufen
	//  (mit auf Ihre Anwendung zugeschnittenen Tips)


	GetDocument()->UpdateAllViews(NULL);
		// im Moment aktualisieren Sie einfach ALLE Ansichten/keine Tips
}

BOOL CEx36bCntrItem::OnChangeItemPosition(const CRect& rectPos)
{
	ASSERT_VALID(this);

	// Whrend einer direkten Aktivierung wird CEx36bCntrItem::OnChangeItemPosition
	//  vom Server aufgerufen, um die Position des In-Place-Fensters 
	//  zu ndern. blicherweise ist dies ein Ergebnis von Datennderungen 
	//  im Server-Dokument, etwa ein gendertes Extent oder als Ergebnis
	//  direkter Grennderungen.
	//
	// Standardmig wird hier die Basisklasse aufgerufen, die wiederum 
	//  COleClientItem::SetItemRects zum Bewegen des Elements
	//  an die neue Position aufruft.

	if (!COleClientItem::OnChangeItemPosition(rectPos))
		return FALSE;

	// ZU ERLEDIGEN: Aktualisieren Sie alle fr das Rechteck/das Extent dieses Elements angelegten Caches

	return TRUE;
}

void CEx36bCntrItem::OnGetItemPosition(CRect& rPosition)
{
	ASSERT_VALID(this);

	// Whrend einer direkten Aktivierung wird CEx36bCntrItem::OnGetItemPosition
	//  zur Bestimmung der Position dieses Elements aufgerufen. Die durch
	//  den Anwendungsassistenten erstellte Standardimplementierung gibt einfach ein 
	//  fest einprogrammiertes Rechteck zurck. Normalerweise gibt dieses Rechteck 
	//  die aktuelle Position des Elements relativ zu der Ansicht an, die zur Aktivierung 
	//  verwendet wird. Sie erhalten die Ansicht, indem Sie CEx36bCntrItem::GetActiveView aufrufen.

	// ZU ERLEDIGEN: Geben Sie das korrekte Rechteck (in Pixeln) in rPosition zurck

	rPosition.SetRect(10, 10, 210, 210);
}

void CEx36bCntrItem::OnActivate()
{
    // Nur Elemente mit direkter Aktivierung pro Rahmen zulassen
    CEx36bView* pView = GetActiveView();
    ASSERT_VALID(pView);
    COleClientItem* pItem = GetDocument()->GetInPlaceActiveItem(pView);
    if (pItem != NULL && pItem != this)
        pItem->Close();
    
    COleClientItem::OnActivate();
}

void CEx36bCntrItem::OnDeactivateUI(BOOL bUndoable)
{
	COleClientItem::OnDeactivateUI(bUndoable);

    // Objekt ausblenden, wenn es kein Outside-In-Objekt ist
    DWORD dwMisc = 0;
    m_lpObject->GetMiscStatus(GetDrawAspect(), &dwMisc);
    if (dwMisc & OLEMISC_INSIDEOUT)
        DoVerb(OLEIVERB_HIDE, NULL);
}

void CEx36bCntrItem::Serialize(CArchive& ar)
{
	ASSERT_VALID(this);

	// Vor dem Lesen von Daten aus COleClientItem zuerst Basisklasse aufrufen.
	// Da dies den von CEx36bCntrItem::GetDocument zurckgegebenen
	//  m_pDocument-Zeiger einrichtet, es ist ratsam, zuerst die Basisklasse 
	//  Serialize aufzurufen.
	COleClientItem::Serialize(ar);

	// jetzt die speziellen Daten fr CEx36bCntrItem einlesen/speichern
	if (ar.IsStoring())
	{
		// ZU ERLEDIGEN: Hier Code zum Speichern einfgen
	}
	else
	{
		// ZU ERLEDIGEN: Hier Code zum Laden einfgen
	}
}

BOOL CEx36bCntrItem::CanActivate()
{
	// Eine direkte Bearbeitung, whrend der Server selbst direkt bearbeitet wird,
	//  funktioniert nicht und wird nicht untersttzt. Deaktivieren Sie deshalb 
	//  in diesem Fall die direkte Aktivierung.
	CEx36bDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	ASSERT(pDoc->IsKindOf(RUNTIME_CLASS(COleServerDoc)));
	if (pDoc->IsInPlaceActive())
		return FALSE;

	// anderenfalls Standardverhalten akzeptieren
	return COleClientItem::CanActivate();
}

/////////////////////////////////////////////////////////////////////////////
// CEx36bCntrItem Diagnose

#ifdef _DEBUG
void CEx36bCntrItem::AssertValid() const
{
	COleClientItem::AssertValid();
}

void CEx36bCntrItem::Dump(CDumpContext& dc) const
{
	COleClientItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
