// CntrItem.h : Schnittstelle der Klasse CEx36bCntrItem
//

class CEx36bDoc;
class CEx36bView;

class CEx36bCntrItem : public COleClientItem
{
	DECLARE_SERIAL(CEx36bCntrItem)

// Konstruktoren
public:
	CEx36bCntrItem(CEx36bDoc* pContainer = NULL);
		// Hinweis: pContainer darf auch NULL sein, um IMPLEMENT_SERIALIZE zuzulassen.
		//  IMPLEMENT_SERIALIZE verlangt, dass die Klasse einen Konstruktor mit
		//  null Argumenten besitzt. Normalerweise werden OLE-Elemente mit einem 
		//  Dokumentzeiger konstruiert, der ungleich Null ist.

// Attribute
public:
	CEx36bDoc* GetDocument()
		{ return (CEx36bDoc*)COleClientItem::GetDocument(); }
	CEx36bView* GetActiveView()
		{ return (CEx36bView*)COleClientItem::GetActiveView(); }

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CEx36bCntrItem)
	public:
	virtual void OnChange(OLE_NOTIFICATION wNotification, DWORD dwParam);
	virtual void OnActivate();
	protected:
	virtual void OnGetItemPosition(CRect& rPosition);
	virtual void OnDeactivateUI(BOOL bUndoable);
	virtual BOOL OnChangeItemPosition(const CRect& rectPos);
	virtual BOOL CanActivate();
	//}}AFX_VIRTUAL

// Implementierung
public:
	~CEx36bCntrItem();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	virtual void Serialize(CArchive& ar);
};

/////////////////////////////////////////////////////////////////////////////
