// ex36bView.h : Schnittstelle der Klasse CEx36bView
//
/////////////////////////////////////////////////////////////////////////////

#include "valform.h"

class CEx36bCntrItem;

class CEx36bView : public CValidForm
{
protected: // Nur aus Serialisierung erzeugen
	CEx36bView();
	DECLARE_DYNCREATE(CEx36bView)

public:
	//{{AFX_DATA(CEx36bView)
	enum { IDD = IDD_EX36B_FORM };
	double	m_dHours;
	CString	m_strEmployee;
	int		m_nJob;
	int		m_nPeriod;
	//}}AFX_DATA

// Attribute
public:
	CEx36bDoc* GetDocument();
	// m_pSelection enthlt die Auswahl des aktuellen CEx36bCntrItem-Objekts.
	// Fr viele Anwendungen ist eine derartige Member-Variable nicht angemessen, um
	//  z.B. eine Mehrfachauswahl oder eine Auswahl von Objekten zu reprsentieren,
	//  die keine CEx36bCntrItem-Objekte sind. Dieser Auswahlmechanismus
	//  dient nur dazu, Ihnen bei den ersten Schritten zu helfen.

	// ZU ERLEDIGEN: Ersetzen Sie diesen Auswahlmechanismus durch einen fr Ihre Anwendung geeigneten.
	CEx36bCntrItem* m_pSelection;

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
    virtual void ValidateDlgItem(CDataExchange* pDX, UINT ID);
	//{{AFX_VIRTUAL(CEx36bView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	virtual void OnInitialUpdate(); // das erste mal nach der Konstruktion aufgerufen
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo*);
	virtual BOOL IsSelected(const CObject* pDocItem) const;// Container-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CEx36bView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CEx36bView)
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInsertObject();
	afx_msg void OnCancelEditCntr();
	afx_msg void OnCancelEditSrvr();
	afx_msg void OnCancel();
	afx_msg void OnSubmit();
	afx_msg void OnServerAddress();
	afx_msg LONG OnPostComplete(UINT wParam, LONG lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in ex36bView.cpp
inline CEx36bDoc* CEx36bView::GetDocument()
   { return (CEx36bDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
